<%@page session="false" import="javax.jcr.*,
        com.day.cq.wcm.api.Page,
        com.day.cq.wcm.api.PageManager,
        org.apache.sling.api.resource.Resource,
        com.day.cq.wcm.commons.WCMUtils,
        com.day.cq.wcm.api.NameConstants,
        com.day.cq.wcm.api.designer.Designer,
        com.day.cq.wcm.api.designer.Design,
        com.day.cq.wcm.api.designer.Style,
        org.apache.sling.api.resource.ValueMap,
        com.day.cq.wcm.api.components.ComponentContext,
        com.day.cq.wcm.api.components.EditContext,
        java.util.Date, java.text.SimpleDateFormat, 
        java.text.FieldPosition, java.text.ParsePosition,
        java.util.Iterator,
        java.util.Calendar,
        javax.jcr.Property,
        javax.jcr.Node,
        javax.jcr.NodeIterator,
        javax.jcr.PropertyType,
        javax.jcr.Session,
        org.slf4j.Logger,
        org.slf4j.LoggerFactory,
        java.util.List,
		java.util.Iterator,
        java.util.ArrayList,
        java.util.Map,
        java.util.HashMap,

         org.apache.sling.api.resource.ResourceResolver,
         org.apache.sling.jcr.api.SlingRepository,
com.day.cq.workflow.*,
com.day.cq.workflow.model.*,
com.day.cq.workflow.exec.*,
com.day.cq.workflow.metadata.*" %><%
%><%@include file="/libs/foundation/global.jsp"%>
<cq:defineObjects/>
<%!
final String resName = "fixScheduledWorkflows";
final String THREAD_NAME = "thread_" + resName;
final String RUNNABLE_NAME = "runnable_" + resName;
%><%

ServletContext ctxt = application.getContext("/apps/tools/components/" + resName);
String cmd = (request.getParameter("cmd") != null)?request.getParameter("cmd"):"";
boolean threadExists = ctxt.getAttribute(THREAD_NAME) != null;
boolean threadIsAlive = threadExists && ((Thread)(ctxt.getAttribute(THREAD_NAME))).isAlive();

String path = "/content/dam";

if("stop".equals(cmd) && threadIsAlive) {
        ((FixWorkflowsThread)(getServletContext().getAttribute(RUNNABLE_NAME))).requestStop();
        ((Thread)(getServletContext().getAttribute(THREAD_NAME))).join();
        %>stopped<%
} else if(!threadIsAlive && "run".equals(cmd)) {
        SlingRepository repository = sling.getService(SlingRepository.class);
        FixWorkflowsThread wft = new FixWorkflowsThread(getServletContext(), repository, sling.getService(WorkflowService.class));
        Thread t = new Thread(wft);
        getServletContext().setAttribute(THREAD_NAME,t);
        getServletContext().setAttribute(RUNNABLE_NAME,wft);
        t.start();
        %>started<%
} else if(threadIsAlive) {
        %>running<%
} else if(!threadIsAlive) {
        %>not running<%
}


%><%!
public class FixWorkflowsThread implements Runnable {
    private final Logger log = LoggerFactory.getLogger(this.getClass().getName());
    private ServletContext ctxt;
    private boolean clearRunning;
    private List listeners;
    private SlingRepository repository;
    private Session jcrSession ;
    private volatile boolean stop;

    private long currentTimeMs = 0;
    private boolean isStoppingMessageOutput = false;
	WorkflowSession wfSession;

	private WorkflowService wfService;

    public FixWorkflowsThread(ServletContext ctxt, SlingRepository repository, WorkflowService wfService) {
        this.ctxt = ctxt; 
        this.clearRunning = clearRunning;
        this.repository = repository ;
        this.wfService = wfService;
        try {
        	jcrSession = repository.loginAdministrative(null) ;
            wfSession = wfService.getWorkflowSession(jcrSession);
        } catch (RepositoryException e) {
            log.error("fixScheduledWorkflows interrupted due to exception", e);
        }

    }

    public void updateBuffer(String msg) {
        log.info(msg);
    }

    public void requestStop() {
        stop = true;   
    }

    public void run() {

        try {
        	log.info("Running fixScheduledWorkflows.");
            currentTimeMs = System.currentTimeMillis();
			long count = rescheduleWorkflows();
            log.info("fixScheduledWorkflows completed, restarted " + count + " workflows, total time: " + (System.currentTimeMillis()-currentTimeMs) + "ms");

        } catch(Exception ie) {
            log.info("FixWorkflowsThread: interrupted");
        } finally {
          if (jcrSession != null) {
            jcrSession.logout();
            jcrSession = null;
            }
            //resourceResolver.close();
            //resourceResolver = null;
            disposeOfThread();
        }
    }

    public long rescheduleWorkflows() {
        long count = 0;
        if (stop) {
            if(!isStoppingMessageOutput) {
                isStoppingMessageOutput = true;
                log.info("Stopping...");
            }
            return count;
        }
        try{ 
            Workflow[] workflows = wfSession.getWorkflows(new String[] {"RUNNING"});
            for(int i = 0; i < workflows.length; i++) {
                Workflow wf = workflows[i];
                String wfModelId = wf.getWorkflowModel().getId();
                if(wfModelId.contains("scheduled_activation") || wfModelId.contains("scheduled_deactivation")) {
                    WorkflowData wfData = wf.getWorkflowData();
                    Object absoluteTime = wfData.getMetaDataMap().get("absoluteTime");
					String payload = wfData.getPayload().toString();
                    log.info("Restarting workflow with absoluteTime: " + absoluteTime + ", payload: " + payload);
                    scheduleWorkflow(payload, wfModelId, absoluteTime);
                    wfSession.terminateWorkflow(wf);
                    count++;
                }
            }
        } catch (Exception e) {
            log.error("Failed to run workflow", e);
        }

        return count;

    }

    public void scheduleWorkflow(String nodePath, String modelPath, Object absoluteTime) {
			 try {
				log.info("Starting workflow for " + nodePath);
			    // Create the workflow data
         		WorkflowData wfData = wfSession.newWorkflowData("JCR_PATH", nodePath);
                WorkflowModel wfModel = wfSession.getModel(modelPath);
				Map<String, Object> metaData = new HashMap<String, Object>();
                metaData.put("absoluteTime", absoluteTime);
          	   // Run the Workflow.
            	wfSession.startWorkflow(wfModel, wfData, metaData);
            } catch (Exception e) {
				log.error("Failed to run workflow for " + nodePath, e);
            }
    }

    public void disposeOfThread() {
        synchronized(this.ctxt) {
            this.ctxt.removeAttribute(THREAD_NAME);
            this.ctxt.removeAttribute(RUNNABLE_NAME);
        }
    }
}
%>